| Airoha M0 BLE API 1.0.5.4

Data Structures | Enumerations | Functions
ble_gatt_client.h

## Data Structures
struct | ble_gatt_evt_err_rsponse_t
| Event parameter of gatt event BLE_GATT_EVT_GET_ERROR_RESPONSE_FROM_SERVER. More...
struct | ble_gatt_evt_mtu_exchange_t
| Event parameter of gatt event BLE_GATT_EVT_MTU_EXCHANGED. More...
struct | ble_gatt_evt_prim_service_discovered_t
| Event parameter of gatt event BLE_GATT_EVT_PRIM_SERVICE_DISCOVERED. More...
struct | ble_gatt_evt_uuid_service_discovered_t
| Event parameter of gatt event BLE_GATT_EVT_UUID_SERVICE_DISCOVERED. More...
struct | ble_gatt_evt_included_service_found_t
| Event parameter of gatt event BLE_GATT_EVT_INCLUDED_SERVICE_FOUND. More...
struct | ble_gatt_evt_service_char_discovered_t
| Event parameter of gatt event BLE_GATT_EVT_SERVICE_CHAR_DISCOVERED. More...
struct | ble_gatt_evt_uuid_char_discovered_t
| Event parameter of gatt event BLE_GATT_EVT_UUID_CHAR_DISCOVERED. More...
struct | ble_gatt_evt_char_descrip_discovered_t
| Event parameter of gatt event BLE_GATT_EVT_CHAR_DESCRIP_DISCOVERED. More...
struct | ble_gatt_evt_char_value_read_t
| Event parameter of gatt event BLE_GATT_EVT_CHAR_VALUE_READ. More...
struct | ble_gatt_evt_uuid_char_read_t
| Event parameter of gatt event BLE_GATT_EVT_UUID_CHAR_READ. More...
struct | ble_gatt_evt_long_char_read_t
| Event parameter of gatt event BLE_GATT_EVT_LONG_CHAR_READ. More...
struct | ble_gatt_evt_multi_char_read_t
| Event parameter of gatt event BLE_GATT_EVT_MULTI_CHAR_READ. More...
struct | ble_gatt_evt_char_value_written_t
| Event parameter of gatt event BLE_GATT_EVT_CHAR_VALUE_WRITTEN. More...
struct | ble_gatt_evt_long_char_written_t
| Event parameter of gatt event BLE_GATT_EVT_LONG_CHAR_WRITTEN. More...
struct | ble_gatt_evt_reliable_write_finished_t
| Event parameter of gatt event BLE_GATT_EVT_RELIABLE_WRITE_FINISHED. More...
struct | ble_gatt_evt_char_descrip_read_t
| Event parameter of gatt event BLE_GATT_EVT_CHAR_DESCRIP_READ. More...
struct | ble_gatt_evt_long_descrip_read_t
| Event parameter of gatt event BLE_GATT_EVT_LONG_DESCRIP_READ. More...
struct | ble_gatt_evt_char_descrip_written_t
| Event parameter of gatt event BLE_GATT_EVT_CHAR_DESCRIP_WRITTEN. More...
struct | ble_gatt_evt_long_descrip_written_t
| Event parameter of gatt event BLE_GATT_EVT_LONG_DESCRIP_WRITTEN. More...
struct | ble_gatt_evt_handle_value_reported_t
| Event parameter of gatt event BLE_GATT_EVT_HANDLE_VALUE_REPORTED. More...
struct | ble_gatt_evt_t
| GATT event structure. More...
struct | GATT_4_3_1_PARA
| GATT Client API parameter for ble_gatt_4_3_1_exchange_mtu. More...
struct | GATT_4_4_1_PARA
| GATT Client API parameter for ble_gatt_4_4_1_disc_all_primary_services. More...
struct | GATT_4_4_2_PARA
| GATT Client API parameter for ble_gatt_4_4_2_disc_primary_service_by_UUID. More...
struct | GATT_4_5_1_PARA
| GATT Client API parameter for ble_gatt_4_5_1_find_included_services. More...
struct | GATT_4_6_1_PARA
| GATT Client API parameter for ble_gatt_4_6_1_disc_all_chars. More...
struct | GATT_4_6_2_PARA
| GATT Client API parameter for ble_gatt_4_6_2_disc_chars_by_UUID. More...
struct | GATT_4_7_1_PARA
| GATT Client API parameter for ble_gatt_4_7_1_disc_all_char_descs. More...
struct | GATT_4_8_1_PARA
| GATT Client API parameter for ble_gatt_4_8_1_read_char_value. More...
struct | GATT_4_8_2_PARA
| GATT Client API parameter for ble_gatt_4_8_2_read_using_char_UUID. More...
struct | GATT_4_8_3_PARA
| GATT Client API parameter for ble_gatt_4_8_3_read_long_char_value. More...
struct | GATT_4_8_4_PARA
| GATT Client API parameter for ble_gatt_4_8_4_read_multi_char_values. More...
struct | GATT_4_9_1_PARA
| GATT Client API parameter for ble_gatt_4_9_1_write_no_rsp. More...
struct | GATT_4_9_2_PARA
| GATT Client API parameter for ble_gatt_4_9_2_signed_write_no_rsp. More...
struct | GATT_4_9_3_PARA
| GATT Client API parameter for ble_gatt_4_9_3_write_char_value. More...
struct | GATT_4_9_4_PARA
| GATT Client API parameter for ble_gatt_4_9_4_write_long_char_value. More...
struct | GATT_4_9_5_PARA
| GATT Client API parameter for ble_gatt_4_9_5_reliable_writes. More...
struct | GATT_4_12_1_PARA
| GATT Client API parameter for ble_gatt_4_12_1_read_char_desc. More...
struct | GATT_4_12_2_PARA
| GATT Client API parameter for ble_gatt_4_12_2_read_long_char_desc. More...
struct | GATT_4_12_3_PARA
| GATT Client API parameter for ble_gatt_4_12_3_write_char_desc. More...
struct | GATT_4_12_4_PARA
| GATT Client API parameter for ble_gatt_4_12_4_write_long_char_desc. More...
union | GATT_PROC_PARA_UNION
| Union of GATT client API parameter. More...

## Enumerations
enum | ble_gatt_event_id { BLE_GATT_EVT_UNEXPECTED_RESPONSE_FROM_SERVER = BT_EVENT_GATT, BLE_GATT_EVT_GET_ERROR_RESPONSE_FROM_SERVER, BLE_GATT_EVT_MTU_EXCHANGED, BLE_GATT_EVT_PRIM_SERVICE_DISCOVERED, BLE_GATT_EVT_UUID_SERVICE_DISCOVERED, BLE_GATT_EVT_INCLUDED_SERVICE_FOUND, BLE_GATT_EVT_SERVICE_CHAR_DISCOVERED, BLE_GATT_EVT_UUID_CHAR_DISCOVERED, BLE_GATT_EVT_CHAR_DESCRIP_DISCOVERED, BLE_GATT_EVT_CHAR_VALUE_READ, BLE_GATT_EVT_UUID_CHAR_READ, BLE_GATT_EVT_LONG_CHAR_READ, BLE_GATT_EVT_MULTI_CHAR_READ, BLE_GATT_EVT_CHAR_VALUE_WRITTEN, BLE_GATT_EVT_LONG_CHAR_WRITTEN, BLE_GATT_EVT_RELIABLE_WRITE_FINISHED, BLE_GATT_EVT_CHAR_DESCRIP_READ, BLE_GATT_EVT_LONG_DESCRIP_READ, BLE_GATT_EVT_CHAR_DESCRIP_WRITTEN, BLE_GATT_EVT_LONG_DESCRIP_WRITTEN, BLE_GATT_EVT_HANDLE_VALUE_REPORTED }
| GATT Event ID enumeration. More...
enum | GATT_STATUS { GATT_SUCCESS, GATT_FAILURE_INVALID_CONNECTION_HANDLE, GATT_FAILURE_INVALID_PARAMETER, GATT_FAILURE_PREVIOUS_PROCEDURE_NOT_ENDED, GATT_FAILURE_TRANSACTION_TIMEOUT }
| GATT Client API status. More...

## Functions
GATT_STATUS | ble_gatt_4_3_1_exchange_mtu (GATT_4_3_1_PARA *para)
| API for starting GATT procedure: Exchange MTU. This API would invoke gatt event BLE_GATT_EVT_MTU_EXCHANGED after procedure is finished successfully. . More...
GATT_STATUS | ble_gatt_4_4_1_disc_all_primary_services (GATT_4_4_1_PARA *para)
| API for starting GATT procedure: Discover All Primary Services. This API would invoke gatt event BLE_GATT_EVT_PRIM_SERVICE_DISCOVERED after procedure is finished successfully. . More...
GATT_STATUS | ble_gatt_4_4_2_disc_primary_service_by_UUID (GATT_4_4_2_PARA *para)
| API for starting GATT procedure: Discover Primary Services By Service UUID. This API would invoke gatt event BLE_GATT_EVT_UUID_SERVICE_DISCOVERED after procedure is finished successfully. . More...
GATT_STATUS | ble_gatt_4_5_1_find_included_services (GATT_4_5_1_PARA *para)
| API for starting GATT procedure: Find Included Services. This API would invoke gatt event BLE_GATT_EVT_INCLUDED_SERVICE_FOUND after procedure is finished successfully. . More...
GATT_STATUS | ble_gatt_4_6_1_disc_all_chars (GATT_4_6_1_PARA *para)
| API for starting GATT procedure: Discover All Characteristic of A Service. This API would invoke gatt event BLE_GATT_EVT_SERVICE_CHAR_DISCOVERED after procedure is finished successfully. . More...
GATT_STATUS | ble_gatt_4_6_2_disc_chars_by_UUID (GATT_4_6_2_PARA *para)
| API for starting GATT procedure: Discover Characteristics by UUID. This API would invoke gatt event BLE_GATT_EVT_UUID_CHAR_DISCOVERED after procedure is finished successfully. . More...
GATT_STATUS | ble_gatt_4_7_1_disc_all_char_descs (GATT_4_7_1_PARA *para)
| API for starting GATT procedure: Discover All Characteristic Descriptors. This API would invoke gatt event BLE_GATT_EVT_CHAR_DESCRIP_DISCOVERED after procedure is finished successfully. . More...
GATT_STATUS | ble_gatt_4_8_1_read_char_value (GATT_4_8_1_PARA *para)
| API for starting GATT procedure: Read Characteristic Value. This API would invoke gatt event BLE_GATT_EVT_CHAR_VALUE_READ after procedure is finished successfully. . More...
GATT_STATUS | ble_gatt_4_8_2_read_using_char_UUID (GATT_4_8_2_PARA *para)
| API for starting GATT procedure: Read Using Characteristic UUID. This API would invoke gatt event BLE_GATT_EVT_UUID_CHAR_READ after procedure is finished successfully. . More...
GATT_STATUS | ble_gatt_4_8_3_read_long_char_value (GATT_4_8_3_PARA *para)
| API for starting GATT procedure: Read Long Characteristic Values. This API would invoke gatt event BLE_GATT_EVT_LONG_CHAR_READ after procedure is finished successfully. . More...
GATT_STATUS | ble_gatt_4_8_4_read_multi_char_values (GATT_4_8_4_PARA *para)
| API for starting GATT procedure: Read Multiple Characteristic Values. This API would invoke gatt event BLE_GATT_EVT_MULTI_CHAR_READ after procedure is finished successfully. . More...
GATT_STATUS | ble_gatt_4_9_1_write_no_rsp (GATT_4_9_1_PARA *para)
| API for starting GATT procedure: Write Without Response. This API would not invoke gatt event. . More...
GATT_STATUS | ble_gatt_4_9_2_signed_write_no_rsp (GATT_4_9_2_PARA *para)
| API for starting GATT procedure: Signed Write Without Response. This API would not invoke gatt event. . More...
GATT_STATUS | ble_gatt_4_9_3_write_char_value (GATT_4_9_3_PARA *para)
| API for starting GATT procedure: Write Characteristic Value. This API would invoke gatt event BLE_GATT_EVT_CHAR_VALUE_WRITTEN after procedure is finished successfully. . More...
GATT_STATUS | ble_gatt_4_9_4_write_long_char_value (GATT_4_9_4_PARA *para)
| API for starting GATT procedure: Write Long Characteristic Values. This API would invoke gatt event BLE_GATT_EVT_LONG_CHAR_WRITTEN after procedure is finished successfully. . More...
GATT_STATUS | ble_gatt_4_9_5_reliable_writes (GATT_4_9_5_PARA *para)
| API for starting GATT procedure: Characteristic Value Reliable Writes. This API would invoke gatt event BLE_GATT_EVT_RELIABLE_WRITE_FINISHED after procedure is finished successfully. . More...
GATT_STATUS | ble_gatt_4_12_1_read_char_desc (GATT_4_12_1_PARA *para)
| API for starting GATT procedure: Read Characteristic Descriptors. This API would invoke gatt event BLE_GATT_EVT_CHAR_DESCRIP_READ after procedure is finished successfully. . More...
GATT_STATUS | ble_gatt_4_12_2_read_long_char_desc (GATT_4_12_2_PARA *para)
| API for starting GATT procedure: Read Long Characteristic Descriptors. This API would invoke gatt event BLE_GATT_EVT_LONG_DESCRIP_READ after procedure is finished successfully. . More...
GATT_STATUS | ble_gatt_4_12_3_write_char_desc (GATT_4_12_3_PARA *para)
| API for starting GATT procedure: Write Characteristic Descriptors. This API would invoke gatt event BLE_GATT_EVT_CHAR_DESCRIP_WRITTEN after procedure is finished successfully. . More...
GATT_STATUS | ble_gatt_4_12_4_write_long_char_desc (GATT_4_12_4_PARA *para)
| API for starting GATT procedure: Write Long Characteristic Descriptors. This API would invoke gatt event BLE_GATT_EVT_LONG_DESCRIP_WRITTEN after procedure is finished successfully. . More...

## Detailed Description

### ble_gatt_client.h

ble_gatt_client.h provides simple API for implementing GATT profiles as the client role.

## Enumeration Type Documentation

## ◆ ble_gatt_event_id

enum ble_gatt_event_id

GATT Event ID enumeration.

Enumerator
BLE_GATT_EVT_UNEXPECTED_RESPONSE_FROM_SERVER | gatt event indicating unexpected response was received from gatt server.
BLE_GATT_EVT_GET_ERROR_RESPONSE_FROM_SERVER | gatt event indicating corresponding gatt procedure was finished abnormally.
BLE_GATT_EVT_MTU_EXCHANGED | gatt event indicating corresponding gatt procedure was finished successfully.
BLE_GATT_EVT_PRIM_SERVICE_DISCOVERED | gatt event indicating corresponding gatt procedure was finished successfully.
BLE_GATT_EVT_UUID_SERVICE_DISCOVERED | gatt event indicating corresponding gatt procedure was finished successfully.
BLE_GATT_EVT_INCLUDED_SERVICE_FOUND | gatt event indicating corresponding gatt procedure was finished successfully.
BLE_GATT_EVT_SERVICE_CHAR_DISCOVERED | gatt event indicating corresponding gatt procedure was finished successfully.
BLE_GATT_EVT_UUID_CHAR_DISCOVERED | gatt event indicating corresponding gatt procedure was finished successfully.
BLE_GATT_EVT_CHAR_DESCRIP_DISCOVERED | gatt event indicating corresponding gatt procedure was finished successfully.
BLE_GATT_EVT_CHAR_VALUE_READ | gatt event indicating corresponding gatt procedure was finished successfully.
BLE_GATT_EVT_UUID_CHAR_READ | gatt event indicating corresponding gatt procedure was finished successfully.
BLE_GATT_EVT_LONG_CHAR_READ | gatt event indicating corresponding gatt procedure was finished successfully.
BLE_GATT_EVT_MULTI_CHAR_READ | gatt event indicating corresponding gatt procedure was finished successfully.
BLE_GATT_EVT_CHAR_VALUE_WRITTEN | gatt event indicating corresponding gatt procedure was finished successfully.
BLE_GATT_EVT_LONG_CHAR_WRITTEN | gatt event indicating corresponding gatt procedure was finished successfully.
BLE_GATT_EVT_RELIABLE_WRITE_FINISHED | gatt event indicating corresponding gatt procedure was finished successfully.
BLE_GATT_EVT_CHAR_DESCRIP_READ | gatt event indicating corresponding gatt procedure was finished successfully.
BLE_GATT_EVT_LONG_DESCRIP_READ | gatt event indicating corresponding gatt procedure was finished successfully.
BLE_GATT_EVT_CHAR_DESCRIP_WRITTEN | gatt event indicating corresponding gatt procedure was finished successfully.
BLE_GATT_EVT_LONG_DESCRIP_WRITTEN | gatt event indicating corresponding gatt procedure was finished successfully.
BLE_GATT_EVT_HANDLE_VALUE_REPORTED | gatt event indicating an attribute value has been reported by gatt server.

## ◆ GATT_STATUS

enum GATT_STATUS

GATT Client API status.

Enumerator
GATT_SUCCESS | success
GATT_FAILURE_INVALID_CONNECTION_HANDLE | invalid connection handle
GATT_FAILURE_INVALID_PARAMETER | invalid parameter
GATT_FAILURE_PREVIOUS_PROCEDURE_NOT_ENDED | previous procedure not ended
GATT_FAILURE_TRANSACTION_TIMEOUT | transaction timeout

## Function Documentation

## ◆ ble_gatt_4_3_1_exchange_mtu()

GATT_STATUS ble_gatt_4_3_1_exchange_mtu | ( | GATT_4_3_1_PARA * | para | ) |

API for starting GATT procedure: Exchange MTU.
This API would invoke gatt event BLE_GATT_EVT_MTU_EXCHANGED after procedure is finished successfully.
.

Parameters

  para | GATT_4_3_1_PARA

Returns
  GATT procedure status GATT_STATUS

## ◆ ble_gatt_4_4_1_disc_all_primary_services()

GATT_STATUS ble_gatt_4_4_1_disc_all_primary_services | ( | GATT_4_4_1_PARA * | para | ) |

API for starting GATT procedure: Discover All Primary Services.
This API would invoke gatt event BLE_GATT_EVT_PRIM_SERVICE_DISCOVERED after procedure is finished successfully.
.

Parameters

  para | GATT_4_4_1_PARA

Returns
  GATT procedure status GATT_STATUS

## ◆ ble_gatt_4_4_2_disc_primary_service_by_UUID()

GATT_STATUS ble_gatt_4_4_2_disc_primary_service_by_UUID | ( | GATT_4_4_2_PARA * | para | ) |

API for starting GATT procedure: Discover Primary Services By Service UUID.
This API would invoke gatt event BLE_GATT_EVT_UUID_SERVICE_DISCOVERED after procedure is finished successfully.
.

Parameters

  para | GATT_4_4_2_PARA

Returns
  GATT procedure status GATT_STATUS

## ◆ ble_gatt_4_5_1_find_included_services()

GATT_STATUS ble_gatt_4_5_1_find_included_services | ( | GATT_4_5_1_PARA * | para | ) |

API for starting GATT procedure: Find Included Services.
This API would invoke gatt event BLE_GATT_EVT_INCLUDED_SERVICE_FOUND after procedure is finished successfully.
.

Parameters

  para | GATT_4_5_1_PARA

Returns
  GATT procedure status GATT_STATUS

## ◆ ble_gatt_4_6_1_disc_all_chars()

GATT_STATUS ble_gatt_4_6_1_disc_all_chars | ( | GATT_4_6_1_PARA * | para | ) |

API for starting GATT procedure: Discover All Characteristic of A Service.
This API would invoke gatt event BLE_GATT_EVT_SERVICE_CHAR_DISCOVERED after procedure is finished successfully.
.

Parameters

  para | GATT_4_6_1_PARA

Returns
  GATT procedure status GATT_STATUS

## ◆ ble_gatt_4_6_2_disc_chars_by_UUID()

GATT_STATUS ble_gatt_4_6_2_disc_chars_by_UUID | ( | GATT_4_6_2_PARA * | para | ) |

API for starting GATT procedure: Discover Characteristics by UUID.
This API would invoke gatt event BLE_GATT_EVT_UUID_CHAR_DISCOVERED after procedure is finished successfully.
.

Parameters

  para | GATT_4_6_2_PARA

Returns
  GATT procedure status GATT_STATUS

## ◆ ble_gatt_4_7_1_disc_all_char_descs()

GATT_STATUS ble_gatt_4_7_1_disc_all_char_descs | ( | GATT_4_7_1_PARA * | para | ) |

API for starting GATT procedure: Discover All Characteristic Descriptors.
This API would invoke gatt event BLE_GATT_EVT_CHAR_DESCRIP_DISCOVERED after procedure is finished successfully.
.

Parameters

  para | GATT_4_7_1_PARA

Returns
  GATT procedure status GATT_STATUS

## ◆ ble_gatt_4_8_1_read_char_value()

GATT_STATUS ble_gatt_4_8_1_read_char_value | ( | GATT_4_8_1_PARA * | para | ) |

API for starting GATT procedure: Read Characteristic Value.
This API would invoke gatt event BLE_GATT_EVT_CHAR_VALUE_READ after procedure is finished successfully.
.

Parameters

  para | GATT_4_8_1_PARA

Returns
  GATT procedure status GATT_STATUS

## ◆ ble_gatt_4_8_2_read_using_char_UUID()

GATT_STATUS ble_gatt_4_8_2_read_using_char_UUID | ( | GATT_4_8_2_PARA * | para | ) |

API for starting GATT procedure: Read Using Characteristic UUID.
This API would invoke gatt event BLE_GATT_EVT_UUID_CHAR_READ after procedure is finished successfully.
.

Parameters

  para | GATT_4_8_2_PARA

Returns
  GATT procedure status GATT_STATUS

## ◆ ble_gatt_4_8_3_read_long_char_value()

GATT_STATUS ble_gatt_4_8_3_read_long_char_value | ( | GATT_4_8_3_PARA * | para | ) |

API for starting GATT procedure: Read Long Characteristic Values.
This API would invoke gatt event BLE_GATT_EVT_LONG_CHAR_READ after procedure is finished successfully.
.

Parameters

  para | GATT_4_8_3_PARA

Returns
  GATT procedure status GATT_STATUS

## ◆ ble_gatt_4_8_4_read_multi_char_values()

GATT_STATUS ble_gatt_4_8_4_read_multi_char_values | ( | GATT_4_8_4_PARA * | para | ) |

API for starting GATT procedure: Read Multiple Characteristic Values.
This API would invoke gatt event BLE_GATT_EVT_MULTI_CHAR_READ after procedure is finished successfully.
.

Parameters

  para | GATT_4_8_4_PARA

Returns
  GATT procedure status GATT_STATUS

## ◆ ble_gatt_4_9_1_write_no_rsp()

GATT_STATUS ble_gatt_4_9_1_write_no_rsp | ( | GATT_4_9_1_PARA * | para | ) |

API for starting GATT procedure: Write Without Response.
This API would not invoke gatt event.
.

Parameters

  para | GATT_4_9_1_PARA

Returns
  GATT procedure status GATT_STATUS

## ◆ ble_gatt_4_9_2_signed_write_no_rsp()

GATT_STATUS ble_gatt_4_9_2_signed_write_no_rsp | ( | GATT_4_9_2_PARA * | para | ) |

API for starting GATT procedure: Signed Write Without Response.
This API would not invoke gatt event.
.

Parameters

  para | GATT_4_9_2_PARA

Returns
  GATT procedure status GATT_STATUS

## ◆ ble_gatt_4_9_3_write_char_value()

GATT_STATUS ble_gatt_4_9_3_write_char_value | ( | GATT_4_9_3_PARA * | para | ) |

API for starting GATT procedure: Write Characteristic Value.
This API would invoke gatt event BLE_GATT_EVT_CHAR_VALUE_WRITTEN after procedure is finished successfully.
.

Parameters

  para | GATT_4_9_3_PARA

Returns
  GATT procedure status GATT_STATUS

## ◆ ble_gatt_4_9_4_write_long_char_value()

GATT_STATUS ble_gatt_4_9_4_write_long_char_value | ( | GATT_4_9_4_PARA * | para | ) |

API for starting GATT procedure: Write Long Characteristic Values.
This API would invoke gatt event BLE_GATT_EVT_LONG_CHAR_WRITTEN after procedure is finished successfully.
.

Parameters

  para | GATT_4_9_4_PARA

Returns
  GATT procedure status GATT_STATUS

## ◆ ble_gatt_4_9_5_reliable_writes()

GATT_STATUS ble_gatt_4_9_5_reliable_writes | ( | GATT_4_9_5_PARA * | para | ) |

API for starting GATT procedure: Characteristic Value Reliable Writes.
This API would invoke gatt event BLE_GATT_EVT_RELIABLE_WRITE_FINISHED after procedure is finished successfully.
.

Parameters

  para | GATT_4_9_5_PARA

Returns
  GATT procedure status GATT_STATUS

## ◆ ble_gatt_4_12_1_read_char_desc()

GATT_STATUS ble_gatt_4_12_1_read_char_desc | ( | GATT_4_12_1_PARA * | para | ) |

API for starting GATT procedure: Read Characteristic Descriptors.
This API would invoke gatt event BLE_GATT_EVT_CHAR_DESCRIP_READ after procedure is finished successfully.
.

Parameters

  para | GATT_4_12_1_PARA

Returns
  GATT procedure status GATT_STATUS

## ◆ ble_gatt_4_12_2_read_long_char_desc()

GATT_STATUS ble_gatt_4_12_2_read_long_char_desc | ( | GATT_4_12_2_PARA * | para | ) |

API for starting GATT procedure: Read Long Characteristic Descriptors.
This API would invoke gatt event BLE_GATT_EVT_LONG_DESCRIP_READ after procedure is finished successfully.
.

Parameters

  para | GATT_4_12_2_PARA

Returns
  GATT procedure status GATT_STATUS

## ◆ ble_gatt_4_12_3_write_char_desc()

GATT_STATUS ble_gatt_4_12_3_write_char_desc | ( | GATT_4_12_3_PARA * | para | ) |

API for starting GATT procedure: Write Characteristic Descriptors.
This API would invoke gatt event BLE_GATT_EVT_CHAR_DESCRIP_WRITTEN after procedure is finished successfully.
.

Parameters

  para | GATT_4_12_3_PARA

Returns
  GATT procedure status GATT_STATUS

## ◆ ble_gatt_4_12_4_write_long_char_desc()

GATT_STATUS ble_gatt_4_12_4_write_long_char_desc | ( | GATT_4_12_4_PARA * | para | ) |

API for starting GATT procedure: Write Long Characteristic Descriptors.
This API would invoke gatt event BLE_GATT_EVT_LONG_DESCRIP_WRITTEN after procedure is finished successfully.
.

Parameters

  para | GATT_4_12_4_PARA

Returns
  GATT procedure status GATT_STATUS